library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.numeric_std.all;

entity transcodeur7s_d_u is
    port (
        I_nombre : in  std_logic_vector(5 downto 0);
        O_uni    : out std_logic_vector (6 downto 0);
        O_diz    : out std_logic_vector (6 downto 0)
        );
end transcodeur7s_d_u;

architecture transcod_ARCH of transcodeur7s_d_u is

    signal SC_u_nombre : unsigned(5 downto 0);
    signal SC_u_uni    : unsigned(5 downto 0);
    signal SC_u_diz    : unsigned(2 downto 0);

begin

    SC_u_nombre <= unsigned(I_nombre);

    p_diz : process (SC_u_nombre) is
    begin
        if (SC_u_nombre < 10) then
            SC_u_diz <= (others => '0');
            SC_u_uni <= SC_u_nombre;
        elsif SC_u_nombre < 20 then
            SC_u_diz <= to_unsigned(1, 3);
            SC_u_uni <= SC_u_nombre - 10;
        elsif SC_u_nombre < 30 then
            SC_u_diz <= to_unsigned(2, 3);
            SC_u_uni <= SC_u_nombre - 20;
        elsif SC_u_nombre < 40 then
            SC_u_diz <= to_unsigned(3, 3);
            SC_u_uni <= SC_u_nombre - 30;
        else
            SC_u_diz <= to_unsigned(4, 3);
            SC_u_uni <= SC_u_nombre - 40;
        end if;
    end process p_diz;


    p_7s_uni : process (SC_u_uni) is
    begin
        case to_integer(SC_u_uni) is
            when 0      => O_uni <= "1000000";
            when 1      => O_uni <= "1111001";
            when 2      => O_uni <= "0100100";
            when 3      => O_uni <= "0110000";
            when 4      => O_uni <= "0011001";
            when 5      => O_uni <= "0010010";
            when 6      => O_uni <= "0000010";
            when 7      => O_uni <= "1111000";
            when 8      => O_uni <= "0000000";
            when others => O_uni <= "0010000";
        end case;
    end process p_7s_uni;

    p_7s_diz : process (SC_u_diz) is
    begin
        case to_integer(SC_u_diz) is
            when 0      => O_diz <= "1000000";
            when 1      => O_diz <= "1111001";
            when 2      => O_diz <= "0100100";
            when 3      => O_diz <= "0110000";
            when others => O_diz <= "0011001";
        end case;
    end process p_7s_diz;



end transcod_ARCH;

architecture transcod_int of transcodeur7s_d_u is

    signal uni_int : integer range 0 to 9;
    signal diz_int : integer range 0 to 4;
    signal num_int : integer range 0 to 49;

begin


    num_int <= to_integer(unsigned(nombre));
    uni_int <= num_int rem 10;
    diz_int <= num_int / 10;

    transc_uni : process (uni_int) is
    begin  -- process transc_uni
        case uni_int is
            when 0      => S_uni <= "1000000";
            when 1      => S_uni <= "1111001";
            when 2      => S_uni <= "0100100";
            when 3      => S_uni <= "0110000";
            when 4      => S_uni <= "0011001";
            when 5      => S_uni <= "0010010";
            when 6      => S_uni <= "0000010";
            when 7      => S_uni <= "1111000";
            when 8      => S_uni <= "0000000";
            when others => S_uni <= "0010000";
        end case;
    end process transc_uni;

    transc_diz : process (diz_int) is
    begin  -- process transc_uni
        case diz_int is
            when 0      => S_diz <= "1000000";
            when 1      => S_diz <= "1111001";
            when 2      => S_diz <= "0100100";
            when 3      => S_diz <= "0110000";
            when others => S_diz <= "0011001";
        end case;
    end process transc_diz;

end transcod_int;
